# file: checks.py
# author: Bob Muller
#
# CS1101 Computer Science I
#

import stddraw, random

# filledRectangle : Picture * float * float * float * float * color -> void
#
# The call filledRectangle(picture, x, y, width, height, color) will
# add to picture a filled rectangle with lower-left corner at (x, y),
# of the specified width, height and color.
#
def filledRectangle(picture, x, y, width, height, color):
    halfWidth = width / 2.0
    halfHeight = height / 2.0
    x0 = x + halfWidth
    y0 = y + halfHeight
    picture.filledRectangle(x0, y0, halfWidth, halfHeight, color)

def filledSquare(picture, x, y, side, color):
    filledRectangle(picture, x, y, side, side, color)

def oneRow(picture, y, side, col):
    if col > 0:
        color = picture.randomColor()
        filledSquare(picture, (col - 1) * side, y, side, color)
        oneRow(picture, y, side, col - 1)

def rows(picture, side, row, n):
    if row > 0:
        oneRow(picture, (row - 1) * side, side, n)
        rows(picture, side, row - 1, n)

def checks(picture, n):
    side = 1.0 / n
    rows(picture, side, n, n)

def start():
    def responder(event):
        checks(picture, 8)
    picture = stddraw.Picture()
    picture.setW(800)
    picture.setH(800)
    picture.bind('<Button-1>', responder)
    picture.start()
